//D-Pixed I/O Class
//
//Load 8bit  k/RLEk None Layers None Mask
//Save None
//

unit DPXPack;

interface
uses
  Windows,Messages,SysUtils,Classes,Graphics;

type
  TDPXImage = class(TBitmap)
  private
    procedure ChangePalette(Stream:TStream);
    procedure ReadNormal(Stream:TStream;imageSize :integer);
    procedure DecodeRLE(Stream:TStream;imageSize :integer);
  public
    procedure LoadFromStream(Stream: TStream); override;
    procedure SaveToStream(Stream: TStream); override;
end;

//[t@Cwb_]
//[J[e[uipbgj]
//  -------------------------------
//    [Cwb_]
//      [J[}XNf[^(IvV)]
//      [J[e[u(IvV)]
//    [CC[Wf[^]          C1
//    [C}XNC[Wf[^]
//  -------------------------------

type
//t@Cwb_160byte
TDPXFILEHEADER=packed record
    Mazic          : array[0..2]  of Char;  //K 'DPX'
    copyright      : array[0..124]of char;  //Rs[Cg
    version        : DWORD;//o[W   ver2.11 "0x00002110"
    dwFlag         : DWORD;//t@C DPF_FILExxxQ
    width          : DWORD;//Width
    height         : DWORD;//Height
    nBitmap        : DWORD;//C
    reserved1      : DWORD;//...
    reserved2      : DWORD;//...
    reserved3      : DWORD;//...
end;

const
 DPF_FILE_HASGLOBALCOLORTABLE= 	$00000001;	//J[e[u(t@Cwb_̌Ƀpbg)
 DPF_FILE_HASGRID 	    =   $00000010;	//Obhf[^
 DPF_FILE_HASFRAME 	    =	$00000020;	//R}gf[^
 DPF_FILE_HASSHAPE 	    =	$00000040;	//ӂf[^

type
//96byte
TDPXFILEIMAGEHEADER_OLD=packed record
  dwSize      : DWORD;                //\̂̃TCY  o[WɂĈႤ璍
  dwFlag      : DWORD;                //tO          DPF_IMAGExxxQ
  keyColor    : DWORD;                //F
  alpha       : DWORD;                //dˍ킹Zx
  maskBit     : DWORD;                //1 }XNf[^k   k̏ꍇ 1,4,8bit
  bgColor     : DWORD;                //wiF
  imageSize   : DWORD;                //C[WTCY
  reserved    : DWORD;                //...
  description : array[0..63] of char; //C̖O
end;

type
//128byte
TDPXFILEIMAGEHEADER_NEW=packed record
  dwSize      : DWORD;                //\̂̃TCY  o[WɂĈႤ璍
  dwFlag      : DWORD;                //tO          DPF_IMAGExxxQ
  keyColor    : DWORD;                //F
  alpha       : DWORD;                //dˍ킹Zx
  maskBit     : DWORD;                //1 }XNf[^k   k̏ꍇ 1,4,8bit
  bgColor     : DWORD;                //wiF
  imageSize   : DWORD;                //C[WTCY
  reserved    : DWORD;                //...
  description : array[0..63] of char; //C̖O
  //ȉ2.10Œǉ
  left        : Integer;              //Aj[V͈͂̐ݒl
  top         : Integer;              //      >>
  right       : Integer;              //      >>
  bottom      : Integer;              //      >>
  delay       : Integer;              //Aj[V̑҂
  animeMode   : Integer;              //Aj[V̔wi[h
  animeInput  : Integer;              //Aj[Ṽ[U͂Lɂ邩ǂ
  animeTransparent:Integer;           //Aj[Vɓ߂邩ǂw肵܂D
  //ȉ2.11Œǉ
  //DPF_IMAGE_COLORMASK̂Ƃ256oCg̃f[^
end;

const

//}XNC[WCC[Wɑ܂D
DPF_IMAGE_HASMASK            =	$00000001;		//(ver2.11ŕW)
//Cp̃pbgCwb_ɑ܂D
DPF_IMAGE_HASLOCALCOLORTABLE =	$00000002;
//}XN摜kĂ܂D
DPF_IMAGE_MASKCOMPRESSED     =	$00000010;		//(ver2.11ŕW)
//C[Wf[^kĂ܂D
DPF_IMAGE_IMAGECOMPRESSED   =	$00000020;		//(ver2.11ŕW)
//C͕\܂D
DPF_IMAGE_ENABLE 	    =   $00010000;
//}XNʂďdˍ킹܂D
DPF_IMAGE_USEALPHAPLANE     = 	$00020000;
//J[}XNf[^Cwb_ɑ܂D
DPF_IMAGE_COLORMASK 	    = 	$00100000;		//2.11


implementation


/////////
procedure TDPXImage.DecodeRLE(Stream:TStream;imageSize :integer);
Var
 MemoryStream :TMemoryStream;
 Buffer : Pointer;
 Lines  : PByteArray;
 foo    : PBYte;
 N      : BYTE;
 X      : Integer;
 Row,Col: Integer;
begin
 MemoryStream:=TMemoryStream.Create;
 MemoryStream.CopyFrom(Stream,imageSize);
 MemoryStream.Position:=0;
 GetMem(Buffer,imageSize);
try
 Move(MemoryStream.Memory^,Buffer^,imageSize);
 Lines :=PByteArray(Buffer);
 MemoryStream.size:=0;
 X:=0;

 While X<>imageSize do
 begin
   if X+1<=imageSize then
   begin
     //lꂩ?
     if Lines[x]=Lines[x+1] then
     begin
      //Run Code is Run
      for N:=0 to Lines[x+2]-1 do
      begin
        MemoryStream.Write(Lines[x],1);
      end;
      X:=X+3;
     end
     else
     begin
       MemoryStream.Write(Lines[x],1);
       inc(x);
     end;
   end
   else
   begin
     MemoryStream.Write(Lines[x],1);
     Break;
   end;
 end;
finally
 FreeMem(Buffer);
end;
MemoryStream.Savetofile('c:\windows\޽į\123.test');

 MemoryStream.Position:=0;
 GetMem(Buffer,MemoryStream.Size);
try
   Move(MemoryStream.Memory^,Buffer^,MemoryStream.Size);
   foo :=PByte(Buffer);

   For Row:=Height-1 Downto 0  do
   begin
     Lines :=Scanline[Row];
     For Col := 0 to Width-1 do
     begin
      Lines[col]:=foo^;
      inc(foo);
     end;
     if (Width mod 4)<>0 then
     begin
        if ((Width+1) mod 4)= 0 then  inc(foo)
        else if ((Width+2) mod 4)= 0 then begin  inc(foo); inc(foo); end
        else
        begin
           inc(foo); inc(foo); inc(foo);
        end
     end;
   end;
finally
 MemoryStream.Free;
 FreeMem(Buffer);
end;

end;

/////////
procedure TDPXImage.ReadNormal(Stream:TStream;imageSize :integer);
Var
 MemoryStream :TMemoryStream;
 Buffer : Pointer;
 foo    : PByte;
 Lines  : PByteArray;
 Row,Col: Integer;
begin
 MemoryStream:=TMemoryStream.Create;
 MemoryStream.CopyFrom(Stream,imageSize);
 MemoryStream.Position:=0;
 GetMem(Buffer,imageSize);
try
 Move(MemoryStream.Memory^,Buffer^,imageSize);
 foo :=PByte(Buffer);
 For Row:=Height-1 Downto 0  do
 begin
     Lines :=Scanline[Row];
     For Col := 0 to Width-1 do
     begin
      Lines[col]:=foo^;
      inc(foo);
     end;
     if (Width mod 4)<>0 then
     begin
        if ((Width+1) mod 4)= 0 then  inc(foo)
        else if ((Width+2) mod 4)= 0 then begin  inc(foo); inc(foo); end
        else
        begin
           inc(foo); inc(foo); inc(foo);
        end
     end;
 end;
finally
 MemoryStream.free;
 Freemem(Buffer);
end;
end;

/////////
procedure TDPXImage.ChangePalette(Stream:TStream );
Var
 i           : Integer;
 RG          : array [0..255] of TRGBQUAD ;
 LogPalette  : TMaxLogPalette ;
begin
   ZeroMemory(@RG,sizeof(TRGBQUAD)*256);
   ZeroMemory(@LogPalette,sizeof(TMaxLogPalette));

   LogPalette.palVersion := $300;
   LogPalette.palNumEntries := 256;

   STream.Read(RG,sizeof(TRGBQUAD)*256);
   for I := 0 to 255 do
   begin
     LogPalette.palPalEntry[I].peBlue  :=RG[i].rgbBlue;
     LogPalette.palPalEntry[I].peGreen :=RG[i].rgbGreen;
     LogPalette.palPalEntry[I].peRed   :=RG[i].rgbRed;;
   end;
   Palette := CreatePalette(PLogPalette(@LogPalette)^);
end;

/////////
procedure TDPXImage.LoadFromStream(Stream: TStream);
Var
 DF : TDPXFILEHEADER;
 DI : TDPXFILEIMAGEHEADER_OLD;
begin
 ZeroMemory(@DF,sizeof(TDPXFILEHEADER));
 ZeroMemory(@DI,sizeof(TDPXFILEIMAGEHEADER_OLD));

 Stream.Read(DF,sizeof(TDPXFILEHEADER));

 if DF.Mazic <>'DPX' then  raise Exception.Create('DPXt@Cł͂܂B');
 //J[pbg邩?
 if (DF.dwFlag and DPF_FILE_HASGLOBALCOLORTABLE) <>DPF_FILE_HASGLOBALCOLORTABLE then  raise Exception.Create('̌`͓Ǎ߂܂');

 //pbg擾
 Pixelformat:=pf8bit;
 Width :=DF.width;
 Height:=DF.height;
 ChangePalette(Stream);

 //Âo[W̍\̂œǍ
 Stream.Read(DI,sizeof(TDPXFILEIMAGEHEADER_OLD));
 Stream.Position:=Stream.Position-sizeof(TDPXFILEIMAGEHEADER_OLD)+DI.dwSize;

 //CJ[e[u()
 if (DI.dwFlag and DPF_IMAGE_HASLOCALCOLORTABLE)=DPF_IMAGE_HASLOCALCOLORTABLE then
  Stream.Position:=Stream.Position+(256*4);

 //ό`RLEk
 if (DI.dwFlag and DPF_IMAGE_IMAGECOMPRESSED)=DPF_IMAGE_IMAGECOMPRESSED then
  DecodeRLE(stream,DI.imageSize)
 else
   //k
  ReadNormal(Stream,DI.imageSize);   
end;

//////////
procedure TDPXImage.SaveToStream(Stream: TStream);
begin
 //None
end;

initialization
  TPicture.RegisterFileFormat('dpx', 'D-Pixed Image Format', TDPXImage);
finalization
  TPicture.UnregisterGraphicClass(TDPXImage);

end.
